package me.kcm.events;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.DamageSource;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;

public class Hooks 
{
    public static void onDamageCalculation(EntityLivingBase liv, DamageSource ds, float damage)
    {
        if(!liv.isEntityInvulnerable(ds))
        {
            MinecraftForge.EVENT_BUS.post(new LivingDamageCalculationEvent(liv, ds, damage));
        }
    }
    
    public static ITextComponent onGetTabListDisplayName(EntityPlayerMP p)
    {
        PlayerTabListNameEvent e = new PlayerTabListNameEvent(p);
        MinecraftForge.EVENT_BUS.post(e);
        return e.getName();
    }
    
    public static boolean onEntityCanTrample(Entity ent, World w, Block b, BlockPos pos, float fallDistance)
    {
        return !MinecraftForge.EVENT_BUS.post(new FarmlandTrampleEvent(w, pos, w.getBlockState(pos), fallDistance, ent));
    }
    
    public static void onPlayerConnection(EntityPlayerMP p)
    {
        System.out.println("CONNECT " + p.getName());
        MinecraftForge.EVENT_BUS.post(new PlayerConnectionEvent(p));
    }
}
